;************************************************************************
; TITLE: 	Programmable Peripheral Controller
; CPU: 		C8051F334
; TARGET:       
; DESC:         I2C support interface to IO MODULE
;************************************************************************
	cpu 8051
	listing off
	relaxed on
	page 0
;---------------------------------------------------------------------------
; 
; 
; FILE NAME: C8051F330.INC
; TARGET MCUs: C8051F330, F331
; DESCRIPTION: Register/bit definitions for the C8051F330 product family.
; REVISION 1.0
;---------------------------------------------------------------------------
;REGISTER DEFINITIONS
P0             SFR 080H    ; PORT 0 LATCH
SP             SFR 081H    ; STACK POINTER
DPL            SFR 082H    ; DATA POINTER LOW
DPH            SFR 083H    ; DATA POINTER HIGH
PCON           SFR 087H    ; POWER CONTROL
TCON           SFR 088H    ; TIMER/COUNTER CONTROL
TMOD           SFR 089H    ; TIMER/COUNTER MODE
TL0            SFR 08AH    ; TIMER/COUNTER 0 LOW
TL1            SFR 08BH    ; TIMER/COUNTER 1 LOW
TH0            SFR 08CH    ; TIMER/COUNTER 0 HIGH
TH1            SFR 08DH    ; TIMER/COUNTER 1 HIGH
CKCON          SFR 08EH    ; CLOCK CONTROL
PSCTL          SFR 08FH    ; PROGRAM STORE R/W CONTROL
P1             SFR 090H    ; PORT 1 LATCH
TMR3CN         SFR 091H    ; TIMER/COUNTER 3 CONTROL
TMR3RLL        SFR 092H    ; TIMER/COUNTER 3 RELOAD LOW
TMR3RLH        SFR 093H    ; TIMER/COUNTER 3 RELOAD HIGH
TMR3L          SFR 094H    ; TIMER/COUNTER 3 LOW
TMR3H          SFR 095H    ; TIMER/COUNTER 3 HIGH
IDA0L          SFR 096H    ; CURRENT MODE DAC0 LOW
IDA0H          SFR 097H    ; CURRENT MODE DAC0 HIGH
SCON0          SFR 098H    ; UART0 CONTROL
SBUF0          SFR 099H    ; UART0 DATA BUFFER
CPT0CN         SFR 09BH    ; COMPARATOR0 CONTROL
CPT0MD         SFR 09DH    ; COMPARATOR0 MODE SELECTION
CPT0MX         SFR 09FH    ; COMPARATOR0 MUX SELECTION
P2             SFR 0A0H    ; PORT 2 LATCH
SPI0CFG        SFR 0A1H    ; SPI CONFIGURATION
SPI0CKR        SFR 0A2H    ; SPI CLOCK RATE CONTROL
SPI0DAT        SFR 0A3H    ; SPI DATA
P0MDOUT        SFR 0A4H    ; PORT 0 OUTPUT MODE CONFIGURATION
P1MDOUT        SFR 0A5H    ; PORT 1 OUTPUT MODE CONFIGURATION
P2MDOUT        SFR 0A6H    ; PORT 2 OUTPUT MODE CONFIGURATION
IE             SFR 0A8H    ; INTERRUPT ENABLE
CLKSEL         SFR 0A9H    ; CLOCK SELECT
EMI0CN         SFR 0AAH    ; EXTERNAL MEMORY INTERFACE CONTROL
OSCXCN         SFR 0B1H    ; EXTERNAL OSCILLATOR CONTROL
OSCICN         SFR 0B2H    ; INTERNAL OSCILLATOR CONTROL
OSCICL         SFR 0B3H    ; INTERNAL OSCILLATOR CALIBRATION
FLSCL          SFR 0B6H    ; FLASH SCALE
FLKEY          SFR 0B7H    ; FLASH LOCK AND KEY
IP             SFR 0B8H    ; INTERRUPT PRIORITY
IDA0CN         SFR 0B9H    ; CURRENT MODE DAC0 CONTROL
AMX0N          SFR 0BAH    ; AMUX0 NEGATIVE CHANNEL SELECT
AMX0P          SFR 0BBH    ; AMUX0 POSITIVE CHANNEL SELECT
ADC0CF         SFR 0BCH    ; ADC0 CONFIGURATION
ADC0L          SFR 0BDH    ; ADC0 LOW
ADC0H          SFR 0BEH    ; ADC0 HIGH
SMB0CN         SFR 0C0H    ; SMBUS CONTROL
SMB0CF         SFR 0C1H    ; SMBUS CONFIGURATION
SMB0DAT        SFR 0C2H    ; SMBUS DATA
ADC0GTL        SFR 0C3H    ; ADC0 GREATER-THAN COMPARE LOW
ADC0GTH        SFR 0C4H    ; ADC0 GREATER-THAN COMPARE HIGH
ADC0LTL        SFR 0C5H    ; ADC0 LESS-THAN COMPARE WORD LOW
ADC0LTH        SFR 0C6H    ; ADC0 LESS-THAN COMPARE WORD HIGH
TMR2CN         SFR 0C8H    ; TIMER/COUNTER 2 CONTROL
TMR2RLL        SFR 0CAH    ; TIMER/COUNTER 2 RELOAD LOW
TMR2RLH        SFR 0CBH    ; TIMER/COUNTER 2 RELOAD HIGH
TMR2L          SFR 0CCH    ; TIMER/COUNTER 2 LOW
TMR2H          SFR 0CDH    ; TIMER/COUNTER 2 HIGH
PSW            SFR 0D0H    ; PROGRAM STATUS WORD
REF0CN         SFR 0D1H    ; VOLTAGE REFERENCE CONTROL
P0SKIP         SFR 0D4H    ; PORT 0 SKIP
P1SKIP         SFR 0D5H    ; PORT 1 SKIP
PCA0CN         SFR 0D8H    ; PCA CONTROL
PCA0MD         SFR 0D9H    ; PCA MODE
PCA0CPM0       SFR 0DAH    ; PCA MODULE 0 MODE REGISTER
PCA0CPM1       SFR 0DBH    ; PCA MODULE 1 MODE REGISTER
PCA0CPM2       SFR 0DCH    ; PCA MODULE 2 MODE REGISTER
ACC            SFR 0E0H    ; ACCUMULATOR
XBR0           SFR 0E1H    ; PORT I/O CROSSBAR CONTROL 0
XBR1           SFR 0E2H    ; PORT I/O CROSSBAR CONTROL 1
OSCLCN         SFR 0E3H    ; LOW-FREQUENCY OSCILLATOR CONTROL
IT01CF         SFR 0E4H    ; INT0/INT1 CONFIGURATION
EIE1           SFR 0E6H    ; EXTENDED INTERRUPT ENABLE 1
ADC0CN         SFR 0E8H    ; ADC0 CONTROL
PCA0CPL1       SFR 0E9H    ; PCA CAPTURE 1 LOW
PCA0CPH1       SFR 0EAH    ; PCA CAPTURE 1 HIGH
PCA0CPL2       SFR 0EBH    ; PCA CAPTURE 2 LOW
PCA0CPH2       SFR 0ECH    ; PCA CAPTURE 2 HIGH
RSTSRC         SFR 0EFH    ; RESET SOURCE CONFIGURATION/STATUS
B              SFR 0F0H    ; B REGISTER
P0MDIN         SFR 0F1H    ; PORT 0 INPUT MODE CONFIGURATION
P1MDIN         SFR 0F2H    ; PORT 1 INPUT MODE CONFIGURATION
EIP1           SFR 0F6H    ; EXTENDED INTERRUPT PRIORITY 1
SPI0CN         SFR 0F8H    ; SPI CONTROL
PCA0L          SFR 0F9H    ; PCA COUNTER LOW
PCA0H          SFR 0FAH    ; PCA COUNTER HIGH
PCA0CPL0       SFR 0FBH    ; PCA CAPTURE 0 LOW
PCA0CPH0       SFR 0FCH    ; PCA CAPTURE 0 HIGH
VDM0CN         SFR 0FFH    ; VDD MONITOR CONTROL
;------------------------------------------------------------------------------
;BIT DEFINITIONS
; TCON 088H
TF1            BIT 08FH     ; TIMER 1 OVERFLOW FLAG
TR1            BIT 08EH     ; TIMER 1 ON/OFF CONTROL
TF0            BIT 08DH     ; TIMER 0 OVERFLOW FLAG
TR0            BIT 08CH     ; TIMER 0 ON/OFF CONTROL
IE1            BIT 08BH     ; EXT. INTERRUPT 1 EDGE FLAG
IT1            BIT 08AH     ; EXT. INTERRUPT 1 TYPE
IE0            BIT 089H     ; EXT. INTERRUPT 0 EDGE FLAG
IT0            BIT 088H     ; EXT. INTERRUPT 0 TYPE
; SCON0 098H
S0MODE         BIT 09FH     ; UART 0 MODE
MCE0           BIT 09DH     ; UART 0 MCE
REN0           BIT 09CH     ; UART 0 RX ENABLE
TB80           BIT 09BH     ; UART 0 TX BIT 8
RB80           BIT 09AH     ; UART 0 RX BIT 8
TI0            BIT 099H     ; UART 0 TX INTERRUPT FLAG
RI0            BIT 098H     ; UART 0 RX INTERRUPT FLAG
; IE 0A8H
EA             BIT 0AFH     ; GLOBAL INTERRUPT ENABLE
ESPI0          BIT 0AEH     ; SPI0 INTERRUPT ENABLE
ET2            BIT 0ADH     ; TIMER 2 INTERRUPT ENABLE
ES0            BIT 0ACH     ; UART0 INTERRUPT ENABLE
ET1            BIT 0ABH     ; TIMER 1 INTERRUPT ENABLE
EX1            BIT 0AAH     ; EXTERNAL INTERRUPT 1 ENABLE
ET0            BIT 0A9H     ; TIMER 0 INTERRUPT ENABLE
EX0            BIT 0A8H     ; EXTERNAL INTERRUPT 0 ENABLE
; IP 0B8H
PSPI0          BIT 0BEH     ; SPI0 PRIORITY
PT2            BIT 0BDH     ; TIMER 2 PRIORITY
PS0            BIT 0BCH     ; UART0 PRIORITY
PT1            BIT 0BBH     ; TIMER 1 PRIORITY
PX1            BIT 0BAH     ; EXTERNAL INTERRUPT 1 PRIORITY
PT0            BIT 0B9H     ; TIMER 0 PRIORITY
PX0            BIT 0B8H     ; EXTERNAL INTERRUPT 0 PRIORITY
; SMB0CN 0C0H
MASTER         BIT 0C7H     ; SMBUS 0 MASTER/SLAVE
TXMODE         BIT 0C6H     ; SMBUS 0 TRANSMIT MODE
STA            BIT 0C5H     ; SMBUS 0 START FLAG
STO            BIT 0C4H     ; SMBUS 0 STOP FLAG
ACKRQ          BIT 0C3H     ; SMBUS 0 ACKNOWLEDGE REQUEST
ARBLOST        BIT 0C2H     ; SMBUS 0 ARBITRATION LOST
ACK            BIT 0C1H     ; SMBUS 0 ACKNOWLEDGE FLAG
SI             BIT 0C0H     ; SMBUS 0 INTERRUPT PENDING FLAG
; TMR2CN 0C8H
TF2H           BIT 0CFH     ; TIMER 2 HIGH BYTE OVERFLOW FLAG
TF2L           BIT 0CEH     ; TIMER 2 LOW BYTE OVERFLOW FLAG
TF2LEN         BIT 0CDH     ; TIMER 2 LOW BYTE INTERRUPT ENABLE
TF2CEN         BIT 0CCH     ; TIMER 2 LFO CAPTURE ENABLE
T2SPLIT        BIT 0CBH     ; TIMER 2 SPLIT MODE ENABLE
TR2            BIT 0CAH     ; TIMER 2 ON/OFF CONTROL
T2XCLK         BIT 0C8H     ; TIMER 2 EXTERNAL CLOCK SELECT
; PSW 0D0H
CY             BIT 0D7H     ; CARRY FLAG
AC             BIT 0D6H     ; AUXILIARY CARRY FLAG
F0             BIT 0D5H     ; USER FLAG 0
RS1            BIT 0D4H     ; REGISTER BANK SELECT 1
RS0            BIT 0D3H     ; REGISTER BANK SELECT 0
OV             BIT 0D2H     ; OVERFLOW FLAG
F1             BIT 0D1H     ; USER FLAG 1
P              BIT 0D0H     ; ACCUMULATOR PARITY FLAG
; PCA0CN 0D8H
CF             BIT 0DFH     ; PCA 0 COUNTER OVERFLOW FLAG
CR             BIT 0DEH     ; PCA 0 COUNTER RUN CONTROL BIT
CCF2           BIT 0DAH     ; PCA 0 MODULE 2 INTERRUPT FLAG
CCF1           BIT 0D9H     ; PCA 0 MODULE 1 INTERRUPT FLAG
CCF0           BIT 0D8H     ; PCA 0 MODULE 0 INTERRUPT FLAG
                            ; ADC 0 WINDOW INTERRUPT FLAG
; ADC0CN 0E8H
AD0EN          BIT 0EFH     ; ADC 0 ENABLE
AD0TM          BIT 0EEH     ; ADC 0 TRACK MODE
AD0INT         BIT 0EDH     ; ADC 0 EOC INTERRUPT FLAG
AD0BUSY        BIT 0ECH     ; ADC 0 BUSY FLAG
AD0WINT        BIT 0EBH     ; ADC 0 WINDOW INTERRUPT FLAG
AD0CM2         BIT 0EAH     ; ADC 0 CONVERT START MODE BIT 2
AD0CM1         BIT 0E9H     ; ADC 0 CONVERT START MODE BIT 1
AD0CM0         BIT 0E8H     ; ADC 0 CONVERT START MODE BIT 0
; SPI0CN 0F8H
SPIF           BIT 0FFH     ; SPI 0 INTERRUPT FLAG
WCOL           BIT 0FEH     ; SPI 0 WRITE COLLISION FLAG
MODF           BIT 0FDH     ; SPI 0 MODE FAULT FLAG
RXOVRN         BIT 0FCH     ; SPI 0 RX OVERRUN FLAG
NSSMD1         BIT 0FBH     ; SPI 0 SLAVE SELECT MODE 1
NSSMD0         BIT 0FAH     ; SPI 0 SLAVE SELECT MODE 0
TXBMT          BIT 0F9H     ; SPI 0 TX BUFFER EMPTY FLAG
SPIEN          BIT 0F8H     ; SPI 0 SPI ENABLE
	listing on
;***************************** CONSTANTS **********************************
SDA	bit P0.0
SCL	bit P0.1
SDA2	bit P2.0
AN0	bit P0.2	;PIN 0 via 100K+10K
AN1	bit P0.3        ;PIN 1  "
AN2	bit P0.6        ;PIN 2  "
AN3	bit P0.7        ;PIN 3  "
RST	bit P0.4        ;Tied to HOST reset line - dr
RXD	bit P0.5
; MODULE I/O
; These pins go directly to the MODULE and are coupled to the
; Propeller I/O by 10K resistors so that this CPU can override
; the Propeller's control as necessary such as fault conditions
M0	bit P1.0	; IO0 and PIN 0 digital input
M1	bit P1.1	; IO1
M2	bit P1.2	; IO2 and PIN 1 digital input
M3	bit P1.3	; IO3
M4	bit P1.4	; IO4 and PIN 2 digital input
M5	bit P1.5	; IO5
M6	bit P1.6	; IO6 and PIN 3 digital input
M7	bit P1.7	; IO7
SYSTEMCLOCK	= 24500000           ; SYSCLK frequency in Hz
BAUDRATE	= 9600           ; Baud rate of UART in bps
;***************************** VARIABLES **********************************
	SEGMENT bitdata
	org 20h
	SEGMENT data
AMUXCH		DS 1
cold		DS 1
;-----------------------------------------------------------------------------
; RESET and INTERRUPT VECTORS
;-----------------------------------------------------------------------------
	SEGMENT code
            ; Reset Vector
	ORG 00h
	ljmp 	Reset                     ; reset vector.
	org 03h
VINT0:
	mov	A,#1
	jmp	TRAP
	org 0bh
VTMR0:	mov	A,#2
	jmp	TRAP
	org 13h
VINT1:	mov	A,#3
	jmp	TRAP
	org 1bh
VTMR1:	mov	A,#4
	jmp	TRAP
	org 23h
VUART0:	mov	A,#5
	jmp	TRAP
	org 2bh
VTMR2:	jmp	Timer2_ISR
	org 33h
VSPI0:	mov	A,#7
	jmp	TRAP
	org 3bh
VSMB0: 	jmp	SMBus_ISR
	org 43h
V8:	mov	A,#9
	jmp	TRAP
	org 4bh
VADCW0:	mov	A,#10
	jmp	TRAP
	org 53h
VADC0:	jmp	ADC0_ISR
	org 5bh
VPCA:	mov	A,#12
	jmp	TRAP
	org 63h
VCOM0:	mov	A,#13
	jmp	TRAP
	org 6bh
V13:	mov	A,#14
	jmp	TRAP
	org 73h
VTMR3:  jmp	Timer3_ISR
;-----------------------------------------------------------------------------
; CODE SEGMENT
;-----------------------------------------------------------------------------
 	org 80h
SLAVEADR:
	db 0F2h		;default i2c address - patch the file directly to change
TITLE:
	db	"PPC I/O V1.0A "
	db	"Analog and digital I/O "
	db	" (BUILD: ",DATE,"-"
BUILD:	db	TIME,")",0
TRAP:   mov	smbstat,A
Reset:
	mov	SP,#0EFh
            ; Disable the WDT.
	anl	PCA0MD, #~(040h)      ; clear Watchdog Enable bit
	orl	OSCICN, #3		; full speed
	mov	CLKSEL,#0
	mov	RSTSRC,#0x04		; Enable missing clock detector
            				; Enable the Port I/O Crossbar
	orl	P0SKIP,#0FCh
	mov	P0MDIN,#033h
	anl	P0MDOUT,#0FCh
	orl	P1SKIP, #0FFh
	orl	P1MDIN,#0FFh		; no analog inputs
	orl	P1MDOUT,#0FFh		; pull pin drivers low (for startup safety)
	mov	P1,#0
	mov	XBR0,#0
	mov	XBR1, #40h              ; enable Crossbar
	call	SMBBUS
	setb	EA			; Global interrupt enable
	call	Timer2_Init
	call    ADC0_Init
MAIN:
	mov	smbstat,smbflg
	mov	smbstat+1,P1
	jnb	smbready,MAIN
	call	PROCESS_SMB
	clr	smbready
	mov	smbcmd,#0
	jmp	MAIN
PROCESS_SMB:
	mov	A,smbcmd
	orl	A,#0
	jnz	PROC1
	ret
PROC1:  cjne	A,#1,PROC2
	mov     P1,smbdat 		; WRITE PORT
	mov	P1MDOUT,smbdat+1        ; WRITE DIR
	ret
PROC2:  cjne	A,#2,PROC2A		; write P1 DIR only
	mov	P1MDOUT,smbdat
	ret
PROC2A: cjne	A,#3,PROC3		; unlock
	mov	P1MDOUT,#0              ; no push-pull
	mov	P1,#0FFh		; release open-drain as well
	ret
PROC3:  cjne	A,#0FDh,PROC4 		;read version
	mov	DPL,#TITLE&0FFh
	mov	DPH,#TITLE/256
	jmp	RDFL
PROC4:  cjne	A,#0FEh,PROC5 		;read flash from address
	mov	DPL,smbdat
	mov	DPH,smbdat+1
RDFL:	mov	r0,#smbtxbuf+SMBTXSZ	; use aux buffer at end of normal tx buffer
	mov	r1,#SMBTXSZ2
rdflp:	clr	A
	movc	A,@A+DPTR
	mov	@r0,A
	inc	DPL
	inc	r0
	djnz	r1,rdflp
	mov	smbTxRd,#SMBTXSZ	; point past end of normal buffer
	ret
PROC5:  cjne	A,#0FFh,PROC6
	jmp	Reset
PROC6:	mov	smbTxRd,smbdat		; set read pointer
	ret
;******************************* ADC *****************************
; Read 2,3,6,7, and 16 (temp)
ADC0_Init:
	mov	AMUXCH,#0
	mov	ADC0CN,#02h		;ADC0 disabled, normal tracking,
                                       ; conversion triggered on TMR2 overflow
	mov	REF0CN,#0Eh		; Vref = VDD, TEMP SENSOR ON
	mov	AMX0P,#0		;ADC0 initial positive input = P0.1
	mov	AMX0N,#11h		; ADC0 negative input = GND
                                        ;i.e., single ended mode
	mov	ADC0CF,#((SYSCLK/3000000)-1)<<3	;Set SAR clock to 3MHz  - right justify
	orl	EIE1,#08h		; Enable ADC0 EOC interrupt
	setb	AD0EN			; Enable ADC0
	ret
Timer2_Init:
	mov	TMR2CN,#0		; Stop Timer2; Clear TF2;
                                        ; use SYSCLK as timebase, 16-bit
                                        ; auto-reload
	orl	CKCON,#010h		; Select SYSCLK for timer 2 source
TMR2VAL = 0FFFFh- (SYSCLK / 10000)
	mov	TMR2RLH,#(TMR2VAL/256) ; Init reload value for 10 us
	mov	TMR2RLL,#(TMR2VAL&0FFh)
	mov	TMR2H,#0ffh		; Set to reload immediately
	mov	TMR2L,#0ffh
	setb	ET2			; Enable Timer2 interrupts
	setb	TR2			; Start Timer2
	ret
; TIMER 2 INTERRUPT SERVIDE ROUTINE
; SELECT NEXT ADC CHANNEL FROM LOOKUP TABLE
Timer2_ISR:
	PUSH    ACC
	PUSH    PSW
	MOV     PSW,#00H
	PUSH    0
	clr	TF2H			; Clear Timer2 interrupt flag
TMX1:	mov	A,AMUXCH
TMX2:	add	A,#1			; table offset
	call	AMUXTBL			; lookup next channel to scan
	orl	A,#0                    ; end of lookup table?
	jnz	TMX3
	mov	AMUXCH,#0               ; reset to beginning of table
	jmp	TMX1 			; reread from start of table
TMX3:	mov	AMX0P,A                 ; select the next ADC channel
;	inc	AMUXCH
	pop	0
	pop	PSW
	pop	ACC
	reti
AMUXTBL:
	movc	A,@A+PC
	ret
	db      2,3,6,7,16,0,0
; ANALOG CONVERTER INTERRUPT SERVICE ROUTINE
ADC0_ISR:
	PUSH    ACC
	PUSH    PSW
	MOV     PSW,#00H
	PUSH    0
	clr	AD0INT
	mov	A,AMUXCH	;write result to latches
	anl	A,#07		; security
	rl	A               ; 2 bytes/sample
	add	A,#adcbuf
	mov	r0,A
	mov	@r0,ADC0L
	inc	r0
	mov	@r0,ADC0H
	inc	AMUXCH
       	pop	0
	pop	PSW
	pop	ACC
	reti
;************************************ I2C ************************
; Read of slave always returns all registers in this order
; READ: STATUS[1],INPUTS[1], ANALOG[4]
; WRITE: CMD, DATA
;SLAVE_ADDR	= 0xF2		; Device addresses (7 bits, lsb is a don't care)
SYSCLK		= 24500000	; System clock frequency in Hz
SMB_FREQUENCY	= 10000		; Target SMBus frequency
				; This example supports between 10kHz
				; and 100kHz
WRITE		= 0x00		; SMBus WRITE command
READ		= 0x01		; SMBus READ command
; Status vector - top 4 bits only
SMB_SRADD	= 0x20		; (SR) slave address received
				;    (also could be a lost
				;    arbitration)
SMB_SRSTO	= 0x10		; (SR) STOP detected while SR or ST,
				;    or lost arbitration
SMB_RX  	= 0x00		; (SR) data byte received, or
                                ;    lost arbitration
SMB_TX		= 0x40		; (ST) data byte transmitted
SMB_STSTO	= 0x50		; (ST) STOP detected during a
                                       ;    transaction; bus error
; End status vector definition
                                       ; Slave -> Master
	segment data
slaveadr	DS 1
smbTxRd 	DS 1
smbRxWr  	DS 1
SMBTXSZ 	= 16
smbtxbuf:	DS SMBTXSZ
;smbrxbuf:
SMBTXSZ2	= 32
		DS SMBTXSZ		; aux buffer
SMBRXSZ 	= 16
smbrxbuf:      DS SMBRXSZ
	segment bitdata
smbflg:		DS 1
smbready	bit smbflg.0		; Set to '1' by the SMBus ISR
rxtx		bit smbflg.1
nomatch		bit smbflg.2
smbdata		bit smbflg.3
smbfull		bit smbflg.4
; bits 5 to 7 are incremented with each I2C operation
;smbstop		bit smbflg.5
					; when a new data byte has been received.
;XBR2	= 0E3h
; 16-bit SFR declarations
;TMR3RL   = 0x92;              ; Timer3 reload registers
;TMR3     = 0x94;              ; Timer3 counter registers
;sbit LED = P1^3;                       ; LED on port P1.3
	segment code
SMBBUS:
	mov	smbflg,#0
	mov	r1,#SMBTXSZ-1
	mov	r0,#smbtxbuf+1
   ; Initialize the outgoing data array in case a read is done before a write
	clr	A
clrsmb:	mov	@r0,A
	inc	r0
	add	A,#4
	djnz	r1,clrsmb
	mov	DPL,#0
	mov	DPH,#0
	mov	A,#SLAVEADR
	movc	A,@A+DPTR
	mov	slaveadr,A
	mov	smbTxRd,#0
	mov	smbRxWr,#0
	acall	PORT_Init		; Initialize Crossbar and GPIO
	acall	Timer1_Init		; Configure Timer1 for SMBus baud rate
;	acall	Timer3_Init		; Configure Timer2 for use with SCL low timeout detect
	acall	SMBus_Init		; Configure and enable SMBus
	ret
SMBus_Init:
	MOV     SMB0CF,#019h ;01DH
	ORL     SMB0CF,#080H
        orl     EIE1,#0x01	; Enable the SMBus interrupt
	RET
Timer1_Init:
	ORL     CKCON,#01H
	ANL     CKCON,#0EDH
	MOV     TMOD,#020H
	MOV     TH1,#034H
	MOV     TL1,TH1
	SETB    TR1
	RET
;Timer3_Init:
;	CLR     A
;	MOV     TMR3CN,A
;	ANL     CKCON,#0DFH
;	MOV     TMR3RL+01H,#038H
;	MOV     TMR3RL,#09FH
;	MOV     TMR3+01H,TMR2RL+01H
;	MOV     TMR3,TMR3RL
;	ORL     IE,#020H
;	SETB    TR3
;	RET
Timer3_Init:
	mov	TMR3CN,#0x00		; Timer3 configured for 16-bit auto-
					; reload, low-byte interrupt disabled
	anl	CKCON,#~0x40		; Timer3 uses SYSCLK/12
        mov     TMR3RLL,#(0-(SYSCLK/12/40))&0FFh&$ff
        mov     TMR3RLL+1,#(0-(SYSCLK/12/40))&0FFh>>8
        mov     TMR3L,TMR3RLL&$ff
        mov     TMR3L+1,TMR3RLL>>8
					; 1/.025 = 40
	orl	EIE1,#0x80		; Timer3 interrupt enable
	orl	TMR3CN,#0x04		; Start Timer3
	ret
PORT_Init:
SMB_IOInit:
	anl	P0MDOUT,#0x03		; All P0 pins open-drain output
	orl	XBR0,#0x04		; Enable SMBus pins
	orl	XBR1,#0x40		; Enable crossbar and weak pull-ups
	mov	P0,#0xFF
	ret
SMBus_ISR:
	MOV     P0MDOUT,#80h
	PUSH    ACC
	PUSH    PSW
	MOV     PSW,#00H
	PUSH    0
	CLR     rxtx
	JNB     ARBLOST,SMBRX
	JMP	SMBRST
SMBRX:
	MOV     A,SMB0CN		; MASTER:TXMODE:STA:STO:ACKRQ:ARBLOST:ACK:SI
	ANL     A,#0F0h
	JZ      SMBRXD 			; 00h RECEIVE DATA
	ADD     A,#0F0H
	JZ      SMBRCVD			; 10h STOP (AFTER SR or ST)
	ADD     A,#0D0H
	JZ      SMBTXD                  ; 40h TX DATA
	ADD     A,#0F0H
	JZ      SMBSTOP			; 50h TX STOP
	ADD     A,#030H
	JNZ     SMBERR                  ; IF NO 20h SLAVE ADDRESS
SMBADR:                                 ; SLAVE ADDRESS
	CLR     STA                     ; CLEAR START FLAG
	mov     smbRxWr,#0
	MOV     A,SMB0DAT
	ANL     A,#0FEH
	XRL     A,slaveadr
	JNZ     UNMATCHED
	SETB    ACK             	; MATCHED SLAVE ADDRESS - ACK
	mov	A,smbflg
	add	A,#$20			; increment I2C counter b5..7
	mov	smbflg,A
	MOV     A,SMB0DAT
	JNB     ACC.0,SMBNEXT 		; R/W  read or write
SMBREAD:
	MOV     A,#smbtxbuf  		; read data
	ADD     A,smbTxRd
	MOV     R0,A
	MOV     A,@R0
	MOV     SMB0DAT,A  		; transmit data
	INC     smbTxRd
	MOV     A,SMB0DAT
	JB      ACC.7,SMBNEXT   	;????????????????
	SETB    STO
	SETB    rxtx			; writing
	SJMP    SMBNEXT
UNMATCHED:
	setb	nomatch
	CLR     ACK
	SJMP    SMBNEXT
SMBRXD:
	setb	smbdata
;	mov     smbTxRd,#0              ; write op always resets read pointers
	MOV     A,smbRxWr
	CLR     C
	SUBB    A,#SMBRXSZ
	MOV     A,#smbrxbuf
	JNC     SMBFULL
	ADD     A,smbRxWr
	MOV     R0,A
	MOV     @R0,SMB0DAT		; SAVE INCOMING DATA INTO BUFFER
	INC     smbRxWr
	SETB    ACK                     ; ACK BYTE has been accepted
	SJMP    SMBNEXT
SMBFULL:
	setb	smbfull
	ADD     A,smbRxWr 		; keep overwriting last byte in rx buffer
	MOV     R0,A
	MOV     @R0,SMB0DAT
;	SETB    smbready              ; definitely full
	SETB    ACK
	SJMP    SMBNEXT
SMBRCVD:
	setb	smbready
;	mov     smbTxRd,#0
SMBSTOP:
	mov     smbTxRd,#0              ; any STOP always resets read pointers
;	setb	smbstop
;	orl	smbRxWr,#0
;	jz	SS1
;	setb	smbready
;	inc	smbstat
SS1:	CLR     STO
	SJMP    SMBNEXT
SMBTXD:
	JNB     ACK,SMBNEXT
;	MOV     A,smbTxRd
;	SETB    C
;	SUBB    A,#SMBTXSZ
;	JNC     SMBNEXT
	MOV     A,#smbtxbuf		; transmit another byte
	ADD     A,smbTxRd
	MOV     R0,A
	MOV     A,@R0
	MOV     SMB0DAT,A
	INC     smbTxRd
	SJMP    SMBNEXT
SMBERR:
	ANL     SMB0CF,#07Fh		; Disable SMB
	ORL     SMB0CF,#080h		; enable SMB (RESETS)
SMBRST:
	CLR     STA
	CLR     STO
	CLR     ACK
SMBNEXT:
	CLR     SI
	JNB     rxtx,SMBRET
	JNB     TXMODE,$		; wait 
	CLR     STO
	CLR     rxtx
SMBRET:
	POP     0
	POP     PSW
	POP     ACC
	RETI
Timer3_ISR:
	ANL     SMB0CF,#07FH
	ORL     SMB0CF,#080H
;	CLR     TF3H
	RETI
smbcmd		= smbrxbuf
smbdat		= smbrxbuf+1
smbstat		= smbtxbuf
adcbuf		= smbtxbuf+2
;-----------------------------------------------------------------------------
; End of file.
END
